﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.ComponentModel.DataAnnotations;
using System.Runtime.CompilerServices;

namespace SystemLead.Project.LK.Server.BZSWeb.Models.MIS
{
    #region SecUser
    public class SecUser : ICloneable, INotifyCompletion
    {
        [Key]
        [Required(ErrorMessage = "使用者代號不可為空白")]
        public string UserNo { get; set; }
        public string UserName { get; set; }
        [Required(ErrorMessage = "密碼不可為空白")]
        public string Pwd { get; set; }
        //解密Pwd
        public string PwdDecrypt { get; set; }
        public string Email { get; set; }
        public string PFacno { get; set; }
        public string PDepno { get; set; }
        [Required(ErrorMessage = "是否啟用不可為空白")]
        public string Enabled { get; set; }
        public string UType { get; set; }
        [Range(1, 99, ErrorMessage = "等級必須在 1 to 99")]
        public short? UClass { get; set; }
        public string ProTitle { get; set; }
        public string Sex { get; set; }
        public string c_UserNoName { get; set; }
        public string ParentId { get; set; }
        public bool Expanded { get; set; }
        public bool HasSubFolders { get; set; }
        public Dictionary<string, Object> htmlAttribute { get; set; }
        public string IconCss { get; set; }
        public bool IsCompleted { get; }
        public void GetResult() { }
        public void OnCompleted(Action continuation) { }
        public int TokenVersion { get; set; }
        public int Level { get; set; }

        #region Constructor
        public SecUser() { }
        public SecUser(string userno,
         string username,
         string pwd,
         string pwddecrypt,
         string email,
         string pfacno,
         string pdepno,
         string enabled,
         string utype,
         short? uclass,
         string protitle,
         string sex,
         string c_usernoname)
        {
            UserNo = userno;
            UserName = username;
            Pwd = pwd;
            PwdDecrypt = pwddecrypt;
            Email = email;
            PFacno = pfacno;
            PDepno = pdepno;
            Enabled = enabled;
            UType = utype;
            UClass = uclass;
            ProTitle = protitle;
            Sex = sex;
            c_UserNoName = c_usernoname;
        }

        #endregion
        #region 以下為程式建立記憶體資料
        public SecUser Clone()
        {
            return ((ICloneable)this).Clone() as SecUser;
        }
        //實作強型別ICloneable介面
        object ICloneable.Clone()
        {
            return this.MemberwiseClone();//使用淺層複製的方法.產出相同屬性值的物件
        }
        #endregion
    }
    #endregion
    #region SecGrp
    public class SecGrp : ICloneable
    {
        [Key]
        [Required(ErrorMessage = "群組代號不可為空白")]
        public string GrpNo { get; set; }
        [Key]
        [Required(ErrorMessage = "使用者代號不可為空白")]
        public string UserNo { get; set; }

        public SecGrp Clone()
        {
            return ((ICloneable)this).Clone() as SecGrp;
        }

        object ICloneable.Clone()
        {
            return this.MemberwiseClone();//使用淺層複製的方法.產出相同屬性值的物件
        }
    }
    #endregion

}
