﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using SystemLead.Project.LK.Server.BZSWeb.Models.MIS;

namespace SystemLead.Project.LK.Server.BZSWeb.Models
{
    public class MyDbContext : DbContext
    {
        public MyDbContext()
        {
        }
        public MyDbContext(DbContextOptions<MyDbContext> options)
                : base(options)
        {

        }
        //宣告對應資料庫之Table
        public DbSet<MisCkind> MisCkind { get; set; }
        public DbSet<MisCode> MisCode { get; set; }
        public DbSet<SecUser> SecUser { get; set; }

        public virtual DbSet<Holuser> Holuser { get; set; }
        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<MisCkind>()
                  .HasKey(c => c.Ckind);
            modelBuilder.Entity<MisCode>()
                  .HasKey(c => new { c.Ckind, c.Code });
            modelBuilder.Entity<SecUser>()
            .HasKey(c => new { c.UserNo });

            modelBuilder.Entity<Holuser>(entity =>
            {
                entity.ToTable("HOLUser");

                entity.Property(e => e.HoluserId).HasColumnName("HOLUserId");

                entity.Property(e => e.Account)
                    .IsRequired()
                    .HasMaxLength(255);

                entity.Property(e => e.Name)
                    .IsRequired()
                    .HasMaxLength(255);

                entity.Property(e => e.Password)
                    .IsRequired()
                    .HasMaxLength(255);
            });

            //OnModelCreatingPartial(modelBuilder);
        }
        //partial void OnModelCreatingPartial(ModelBuilder modelBuilder);

    }
}
