using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using SystemLead.Project.LK.Server.BZSWeb.Services.MIS;
using SystemLead.Project.LK.Server.BZSWeb.Models.MIS;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authentication.Cookies;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace SystemLead.Project.LK.Server.BZSWeb.Pages
{
    [AllowAnonymous]
    public class LoginModel : PageModel
    {
        private readonly IMisService misService;

        public LoginModel(IMisService misService)
        {
#if DEBUG
            Username = "mis";
            Password = "*IK<(OL>";
            PasswordType = "";
            this.misService = misService;
#endif
        }
        [BindProperty]
        public string Username { get; set; } = "";

        [BindProperty]
        public string Password { get; set; } = "";
        public string PasswordType { get; set; } = "password";
        public string Msg { get; set; }
        public async Task OnGetAsync()
        {
            try
            {
                // MwgsbnJ Cookie e
                await HttpContext
                    .SignOutAsync(
                    CookieAuthenticationDefaults.AuthenticationScheme);
            }
            catch { }
        }
        public string ReturnUrl { get; set; }
        public async Task<IActionResult> OnPostAsync()
        {
            //(Holuser user, string message) = await holuserService.CheckUser(Username, Password);
            (SecUser user, string message) = await misService.CheckAsync_SecUser(Username, Password, 3);
            if (user == null)
            {
                Msg = message;
            }
            else
            {
                string returnUrl = Url.Content("~/");

                #region [JoӨϥΪ̻ݭnΨ쪺 ŧi Claim Type
                var claims = new List<Claim>
                {
                    new Claim(ClaimTypes.Role, "User"),
                    new Claim(ClaimTypes.Name, user.UserName),
                    new Claim("TokenVersion", user.TokenVersion.ToString()),
                };
                if (user.Level == 4)
                {
                    claims.Add(new Claim(ClaimTypes.Role, "Administrator"));
                }
                #endregion

                #region إ ŧiѧO
                // ClaimsIdentityOOŧiѧO, ]NOŧiXҴyzѧO
                var claimsIdentity = new ClaimsIdentity(
                    claims, CookieAuthenticationDefaults.AuthenticationScheme);
                #endregion

                #region إ{ҶqݭnxsA
                var authProperties = new AuthenticationProperties
                {
                    IsPersistent = true,
                    RedirectUri = this.Request.Host.Value
                };
                #endregion

                #region iϥεnJ
                try
                {
                    await HttpContext.SignInAsync(
                    CookieAuthenticationDefaults.AuthenticationScheme,
                    new ClaimsPrincipal(claimsIdentity),
                    authProperties);
                }
                catch (Exception ex)
                {
                    string error = ex.Message;
                }
                #endregion

                return LocalRedirect(returnUrl);
            }
            return Page();
        }
    }
}
