﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using SystemLead.Project.LK.Server.BZSWeb.Models.MIS;

namespace SystemLead.Project.LK.Server.BZSWeb.Services.MIS
{
    public interface IMisService
    {
        #region MisUnit
        Task<List<MisUnit>> RetriveAsync_MisUnit(MisUnit arg_misunit, int nOperationType);
        List<MisUnit> Retrive_MisUnit(MisUnit arg_misunit, int nOperationType);
        #endregion
        #region MisDept
        Task<List<MisDept>> RetriveAsync_MisDept(MisDept arg_misdept, int nOperationType);
        List<MisDept> Retrive_MisDept(MisDept arg_misdept, int nOperationType);
        List<TreeItem> Retrive_MisDeptTree(MisDept arg_misdept, int nOperationType);
        #endregion
        #region MisCkind
        Task CreateAsync_MisCkind(MisCkind arg_misCkind);
        Task DeleteAsync_MisCkind(MisCkind arg_misCkind);
        Task<List<MisCkind>> RetriveAsync_MisCkind(MisCkind arg_misckind, int nOperationType);
        Task UpdateAsync_MisCkind(MisCkind arg_misCkind);
        #endregion
        #region MisCode
        Task CreateAsync_MisCode(MisCode arg_misCode);
        Task DeleteAsync_MisCode(MisCode arg_misCode);
        Task<List<MisCode>> RetriveAsync_MisCode(MisCode arg_miscode, int nOperationType);
        Task UpdateAsync_MisCode(MisCode arg_misCode);
        #endregion
        #region MisGrp
        Task CreateAsync_MisGrp(MisGrp arg_misGrp);
        Task DeleteAsync_MisGrp(MisGrp arg_misGrp);
        Task<List<MisGrp>> RetriveAsync_MisGrp(MisGrp arg_misgrp, int nOperationType);
        Task<List<TreeItem>> RetriveAsync_MisGrpUserTree(MisGrp arg_misgrp, int nOperationType);
        List<MisGrp> Retrive_MisGrp(MisGrp arg_misgrp, int nOperationType);
        Task UpdateAsync_MisGrp(MisGrp arg_misGrp);
        #endregion
        #region SecUser
        Task CreateAsync_SecUser(SecUser arg_secUser);
        Task DeleteAsync_SecUser(SecUser arg_secUser);
        Task<List<SecUser>> RetriveAsync_SecUser(SecUser arg_secUser, int nOperationType);
        Task UpdateAsync_SecUser(SecUser arg_secUser);
        Task<SecUser> Get_SecUser(string arg_userNo);
        List<SecUser> Retrive_SecUser(SecUser arg_secUser, int nOperationType);
        List<TreeItem1> Retrive_SecUserTree(SecUser arg_secUser, int nOperationType);

        Task<(SecUser, string)> CheckAsync_SecUser(string account, string password, int nOperationType);
        #endregion
        #region SecGrp
        Task CreateAsync_SecGrp(SecGrp arg_secGrp);
        Task DeleteAsync_SecGrp(SecGrp arg_secGrp);
        Task<List<SecGrp>> RetriveAsync_SecGrp(SecGrp arg_secgrp, int nOperationType);
        List<SecGrp> Retrive_SecGrp(SecGrp arg_secgrp, int nOperationType);
        #endregion


    }
}
