﻿using Microsoft.Extensions.Configuration;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Data;
using SystemLead.Project.LK.Server.BZSWeb.Models.MIS;
using Microsoft.Data.SqlClient;
using Dapper;
using SystemLead.Framework;


namespace SystemLead.Project.LK.Server.BZSWeb.Services.MIS
{
    public class MisDbDapperService : IMisService
    {
        public IConfiguration _Configuration { get; }
        public string _connectionString = "";

        public MisDbDapperService(IConfiguration configuration)
        {
            _Configuration = configuration;
            _connectionString = _Configuration.GetConnectionString("DefaultConnection");
        }
        #region MisUnit
        public async Task<List<MisUnit>> RetriveAsync_MisUnit(MisUnit arg_misunit, int nOperationType)
        {
            List<MisUnit> _oMisUnits = new List<MisUnit>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oMisUnits = con.QueryAsync<MisUnit>("SP_MisUnit_R"
               , this.SetParmeters_MisUnit_R(arg_misunit, nOperationType),
               commandType: CommandType.StoredProcedure);
                if (oMisUnits != null && oMisUnits.Result.Any())
                {
                    _oMisUnits = (List<MisUnit>)await oMisUnits;
                }
            }
            return _oMisUnits;
        }
        public List<MisUnit> Retrive_MisUnit(MisUnit arg_misunit, int nOperationType)
        {
            List<MisUnit> _oMisUnits = new List<MisUnit>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oMisUnits = con.Query<MisUnit>("SP_MisUnit_R"
               , this.SetParmeters_MisUnit_R(arg_misunit, nOperationType),
               commandType: CommandType.StoredProcedure);
                if (oMisUnits != null && oMisUnits.Any())
                {
                    _oMisUnits = (List<MisUnit>)oMisUnits;
                }
            }
            return _oMisUnits;
        }
        private DynamicParameters SetParmeters_MisUnit_R(MisUnit oMisUnit, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@facno", oMisUnit.FacNo);
            obj.Add("@facname", oMisUnit.FacName);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }

        #endregion
        #region MisDept
        public async Task<List<MisDept>> RetriveAsync_MisDept(MisDept arg_misdept, int nOperationType)
        {
            List<MisDept> _oMisDepts = new List<MisDept>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oMisDepts = con.QueryAsync<MisDept>("SP_MisDept_R"
                       , this.SetParmeters_MisDept_R(arg_misdept, nOperationType),
                       commandType: CommandType.StoredProcedure);
                if (oMisDepts != null && oMisDepts.Result.Any())
                {
                    _oMisDepts = (List<MisDept>)await oMisDepts;
                }
            }
            return _oMisDepts;
        }

        public List<MisDept> Retrive_MisDept(MisDept arg_misdept, int nOperationType)
        {
            List<MisDept> _oMisDepts = new List<MisDept>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oMisDepts = con.Query<MisDept>("SP_MisDept_R"
                       , this.SetParmeters_MisDept_R(arg_misdept, nOperationType),
                       commandType: CommandType.StoredProcedure);
                if (oMisDepts != null && oMisDepts.Any())
                {
                    _oMisDepts = (List<MisDept>)oMisDepts;
                }
            }
            return _oMisDepts;
        }
        public List<TreeItem> Retrive_MisDeptTree(MisDept arg_misdept, int nOperationType)
        {
            List<TreeItem> _oMisDepts = new List<TreeItem>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oMisDepts = con.Query<TreeItem>("SP_MisDept_R"
                       , this.SetParmeters_MisDept_R(arg_misdept, nOperationType),
                       commandType: CommandType.StoredProcedure);
                if (oMisDepts != null && oMisDepts.Any())
                {
                    _oMisDepts = (List<TreeItem>)oMisDepts;
                }
            }
            return _oMisDepts;
        }
        private DynamicParameters SetParmeters_MisDept_R(MisDept oMisDept, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@facno", oMisDept.FacNo);
            obj.Add("@depno", oMisDept.DepNo);
            obj.Add("@depname", oMisDept.DepName);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }

        #endregion

        #region MisCkind
        public async Task CreateAsync_MisCkind(MisCkind arg_misCkind)
        {
            MisCkind _oMisCkind = new MisCkind();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                //依operationType判斷新增或更新
                var oMisCkinds = con.QueryAsync<MisCkind>("SP_MisCkind_CUD"
                    , this.SetParmeters_MisCkind(arg_misCkind, 1),
                    commandType: CommandType.StoredProcedure);

                if (oMisCkinds != null && oMisCkinds.Result.Any())
                {
                    _oMisCkind = (MisCkind)await oMisCkinds;
                }
            }

        }
        private DynamicParameters SetParmeters_MisCkind(MisCkind oMisCkind, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@ckind", oMisCkind.Ckind);
            obj.Add("@ckdesc", oMisCkind.Ckdesc);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }
        public async Task DeleteAsync_MisCkind(MisCkind arg_misCkind)
        {
            MisCkind _oMisCkind;
            using (IDbConnection con = new SqlConnection(_connectionString))
            {

                _oMisCkind = new MisCkind()
                {
                    Ckind = arg_misCkind.Ckind
                };

                if (con.State == ConnectionState.Closed) con.Open();
                await con.QueryAsync<MisCkind>("SP_MisCkind_CUD"
                    , this.SetParmeters_MisCkind(_oMisCkind, 3),
                    commandType: CommandType.StoredProcedure);
            }
        }
        public async Task<List<MisCkind>> RetriveAsync_MisCkind(MisCkind arg_misckind, int nOperationType)
        {
            List<MisCkind> _oMisCkinds = new List<MisCkind>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oMisCkinds = con.QueryAsync<MisCkind>("SP_MisCkind_R"
               , this.SetParmeters_MisCkind_R(arg_misckind, nOperationType),
               commandType: CommandType.StoredProcedure);
                if (oMisCkinds != null && oMisCkinds.Result.Any())
                {
                    _oMisCkinds = (List<MisCkind>)await oMisCkinds;
                }
            }
            return _oMisCkinds;
        }
        private DynamicParameters SetParmeters_MisCkind_R(MisCkind oMisCkind, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@ckind", oMisCkind.Ckind);
            obj.Add("@ckdesc", oMisCkind.Ckdesc);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }
        public async Task UpdateAsync_MisCkind(MisCkind arg_misCkind)
        {
            MisCkind _oMisCkind = new MisCkind();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                //依operationType判斷新增或更新
                var oMisCkinds = con.QueryAsync<MisCkind>("SP_MisCkind_CUD"
                    , this.SetParmeters_MisCkind(arg_misCkind, 2),
                    commandType: CommandType.StoredProcedure);

                if (oMisCkinds != null && oMisCkinds.Result.Any())
                {
                    _oMisCkind = (MisCkind)await oMisCkinds;
                }
            }
        }
        #endregion
        #region MisCode
        public async Task CreateAsync_MisCode(MisCode arg_misCode)
        {
            //throw new NotImplementedException();
            MisCode _oMisCode = new MisCode();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                //依operationType判斷新增或更新
                var oMisCodes = con.QueryAsync<MisCode>("SP_MisCode_CUD"
                    , this.SetParmeters_MisCode(arg_misCode, 1),
                    commandType: CommandType.StoredProcedure);

                if (oMisCodes != null && oMisCodes.Result.Any())
                {
                    _oMisCode = (MisCode)await oMisCodes;
                }
            }
        }
        private DynamicParameters SetParmeters_MisCode(MisCode oMisCode, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@ckind", oMisCode.Ckind);
            obj.Add("@code", oMisCode.Code);
            obj.Add("@cdesc", oMisCode.Cdesc);
            obj.Add("@status", oMisCode.Status);
            obj.Add("@cdesc_s", oMisCode.Cdesc_s);
            obj.Add("@cdesc_e", oMisCode.Cdesc_e);
            obj.Add("@cdesc_j", oMisCode.Cdesc_j);
            obj.Add("@cdesc_o", oMisCode.Cdesc_o);
            obj.Add("@memo", oMisCode.Memo);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }
        public async Task DeleteAsync_MisCode(MisCode arg_misCode)
        {
            MisCode _oMisCode;
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                _oMisCode = new MisCode()
                {
                    Ckind = arg_misCode.Ckind,
                    Code = arg_misCode.Code
                };

                if (con.State == ConnectionState.Closed) con.Open();
                await con.QueryAsync<MisCode>("SP_MisCode_CUD"
                    , this.SetParmeters_MisCode(_oMisCode, 3),
                    commandType: CommandType.StoredProcedure);
            }
        }
        public async Task<List<MisCode>> RetriveAsync_MisCode(MisCode arg_miscode, int nOperationType)
        {
            List<MisCode> _oMisCodes = new List<MisCode>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oMisCodes = con.QueryAsync<MisCode>("SP_MisCode_R"
                       , this.SetParmeters_MisCode_R(arg_miscode, nOperationType),
                       commandType: CommandType.StoredProcedure);
                if (oMisCodes != null && oMisCodes.Result.Any())
                {
                    _oMisCodes = (List<MisCode>)await oMisCodes;
                }
            }
            return _oMisCodes;
        }
        private DynamicParameters SetParmeters_MisCode_R(MisCode oMisCode, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@ckind", oMisCode.Ckind);
            obj.Add("@code", oMisCode.Code);
            obj.Add("@cdesc", oMisCode.Cdesc);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }
        public async Task UpdateAsync_MisCode(MisCode arg_misCode)
        {
            //throw new NotImplementedException();
            MisCode _oMisCode = new MisCode();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                //依operationType判斷新增或更新
                var oMisCodes = con.QueryAsync<MisCode>("SP_MisCode_CUD"
                    , this.SetParmeters_MisCode(arg_misCode, 2),
                    commandType: CommandType.StoredProcedure);

                if (oMisCodes != null && oMisCodes.Result.Any())
                {
                    _oMisCode = (MisCode)await oMisCodes;
                }
            }

        }
        #endregion
        #region MisGrp
        public async Task<List<MisGrp>> RetriveAsync_MisGrp(MisGrp arg_misgrp, int nOperationType)
        {
            List<MisGrp> _oMisGrps = new List<MisGrp>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oMisGrps = con.QueryAsync<MisGrp>("SP_MisGrp_R"
                , this.SetParmeters_MisGrp_R(arg_misgrp, nOperationType),
                commandType: CommandType.StoredProcedure);

                if (oMisGrps != null && oMisGrps.Result.Any())
                {
                    _oMisGrps = (List<MisGrp>)await oMisGrps;
                }
            }
            return _oMisGrps;
        }
        public List<MisGrp> Retrive_MisGrp(MisGrp arg_misgrp, int nOperationType)
        {
            List<MisGrp> _oMisGrps = new List<MisGrp>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oMisGrps = con.Query<MisGrp>("SP_MisGrp_R"
                           , this.SetParmeters_MisGrp_R(arg_misgrp, nOperationType),
                           commandType: CommandType.StoredProcedure);

                if (oMisGrps != null && oMisGrps.Any())
                {
                    _oMisGrps = (List<MisGrp>)oMisGrps;
                }
            }
            return _oMisGrps;
        }
        public async Task<List<TreeItem>> RetriveAsync_MisGrpUserTree(MisGrp arg_misgrp, int nOperationType)
        {
            List<TreeItem> _oMisGrps = new List<TreeItem>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oMisGrps = con.QueryAsync<TreeItem>("SP_MisGrpUser_R"
                , this.SetParmeters_MisGrp_R(arg_misgrp, nOperationType),
                commandType: CommandType.StoredProcedure);

                if (oMisGrps != null && oMisGrps.Result.Any())
                {
                    _oMisGrps = (List<TreeItem>)await oMisGrps;
                }
            }
            return _oMisGrps;
        }
        private DynamicParameters SetParmeters_MisGrp_R(MisGrp oMisGrp, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@grpno", oMisGrp.GrpNo);
            obj.Add("@grpname", oMisGrp.GrpName);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }
        public async Task CreateAsync_MisGrp(MisGrp arg_misGrp)
        {
            MisGrp _oMisGrp = new MisGrp();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                //依operationType判斷新增或更新
                var oMisGrps = con.QueryAsync<MisGrp>("SP_MisGrp_CUD"
                    , this.SetParmeters_MisGrp(arg_misGrp, 1),
                    commandType: CommandType.StoredProcedure);

                if (oMisGrps != null && oMisGrps.Result.Any())
                {
                    _oMisGrp = (MisGrp)await oMisGrps;
                }
            }
        }
        private DynamicParameters SetParmeters_MisGrp(MisGrp oMisGrp, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@grpno", oMisGrp.GrpNo);
            obj.Add("@grpname", oMisGrp.GrpName);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }
        public async Task DeleteAsync_MisGrp(MisGrp arg_misGrp)
        {
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                await con.QueryAsync<MisGrp>("SP_MisGrp_CUD"
                    , this.SetParmeters_MisGrp(arg_misGrp, 3),
                    commandType: CommandType.StoredProcedure);
            }
        }
        public async Task UpdateAsync_MisGrp(MisGrp arg_misGrp)
        {
            MisGrp _oMisGrp = new MisGrp();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                //依operationType判斷新增或更新
                var oMisGrps = con.QueryAsync<MisGrp>("SP_MisGrp_CUD"
                    , this.SetParmeters_MisGrp(arg_misGrp, 2),
                    commandType: CommandType.StoredProcedure);

                if (oMisGrps != null && oMisGrps.Result.Any())
                {
                    _oMisGrp = (MisGrp)await oMisGrps;
                }
            }
        }
        #endregion

        #region SecUser
        public async Task CreateAsync_SecUser(SecUser arg_secUser)
        {
            SecUser _oSecUser = new SecUser();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();

                //依operationType判斷新增或更新
                var oSecUsers = await con.QueryFirstOrDefaultAsync<SecUser>("SP_SecUser_CUD"
                    , this.SetParmeters_SecUser_CUD(arg_secUser, 1),
                    commandType: CommandType.StoredProcedure);

                if (oSecUsers != null)
                {
                    _oSecUser = (SecUser)oSecUsers;
                }
            }
        }
        public async Task UpdateAsync_SecUser(SecUser arg_secUser)
        {
            //throw new NotImplementedException();
            SecUser _oSecUser = new SecUser();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                //依operationType判斷新增或更新
                var oSecUsers = con.QueryAsync<SecUser>("SP_SecUser_CUD"
                    , this.SetParmeters_SecUser_CUD(arg_secUser, 2),
                    commandType: CommandType.StoredProcedure);

                if (oSecUsers != null && oSecUsers.Result.Any())
                {
                    _oSecUser = (SecUser)await oSecUsers;
                }
            }
        }
        public async Task DeleteAsync_SecUser(SecUser arg_secUser)
        {
            SecUser _oSecUser;
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                _oSecUser = new SecUser()
                {
                    UserNo = arg_secUser.UserNo
                };

                if (con.State == ConnectionState.Closed) con.Open();
                await con.QueryAsync<SecUser>("SP_SecUser_CUD"
                    , this.SetParmeters_SecUser_CUD(_oSecUser, 3),
                    commandType: CommandType.StoredProcedure);
            }

        }
        private DynamicParameters SetParmeters_SecUser_CUD(SecUser oSecUser, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@userno", oSecUser.UserNo);
            obj.Add("@username", oSecUser.UserName);
            obj.Add("@pwd", oSecUser.Pwd);
            obj.Add("@email", oSecUser.Email);
            obj.Add("@pfacno", oSecUser.PFacno);
            obj.Add("@pdepno", oSecUser.PDepno);
            obj.Add("@enabled", oSecUser.Enabled);
            obj.Add("@utype", oSecUser.UType);
            obj.Add("@uclass", oSecUser.UClass);
            obj.Add("@protitle", oSecUser.ProTitle);
            obj.Add("@sex", oSecUser.Sex);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }
        public async Task<List<SecUser>> RetriveAsync_SecUser(SecUser arg_secUser, int nOperationType)
        {
            List<SecUser> _oSecUsers = new List<SecUser>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oSecUsers = con.QueryAsync<SecUser>("SP_SecUser_R"
                  , this.SetParmeters_SecUser_R(arg_secUser, nOperationType),
                  commandType: CommandType.StoredProcedure);
                if (oSecUsers != null && oSecUsers.Result.Any())
                {
                    _oSecUsers = (List<SecUser>)await oSecUsers;
                }
            }
            return _oSecUsers;
        }
        public List<SecUser> Retrive_SecUser(SecUser arg_secUser, int nOperationType)
        {
            List<SecUser> _oSecUsers = new List<SecUser>();
            SecUser _oSecUser;
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                _oSecUser = new SecUser()
                {
                    UserNo = arg_secUser.UserNo,
                    UserName = arg_secUser.UserName,
                    PFacno = arg_secUser.PFacno,
                    PDepno = arg_secUser.PDepno
                };
                if (con.State == ConnectionState.Closed) con.Open();
                var oSecUsers = con.Query<SecUser>("SP_SecUser_R"
                    , this.SetParmeters_SecUser_R(_oSecUser, nOperationType),
                    commandType: CommandType.StoredProcedure);
                if (oSecUsers != null && oSecUsers.Any())
                {
                    _oSecUsers = (List<SecUser>)oSecUsers;
                }
            }
            return _oSecUsers;
        }
        public List<TreeItem1> Retrive_SecUserTree(SecUser arg_secUser, int nOperationType)
        {
            List<TreeItem1> _oSecUsers = new List<TreeItem1>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oSecUsers = con.Query<TreeItem1>("SP_SecUser_R"
                    , this.SetParmeters_SecUser_R(arg_secUser, nOperationType),
                    commandType: CommandType.StoredProcedure);
                if (oSecUsers != null && oSecUsers.Any())
                {
                    _oSecUsers = (List<TreeItem1>)oSecUsers;
                }
            }
            return _oSecUsers;
        }
        private DynamicParameters SetParmeters_SecUser_R(SecUser oSecUser, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@userno", oSecUser.UserNo);
            obj.Add("@username", oSecUser.UserName);
            obj.Add("@pfacno", oSecUser.PFacno);
            obj.Add("@pdepno", oSecUser.PDepno);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }
        public Task<SecUser> Get_SecUser(string arg_userNo)
        {
            throw new NotImplementedException();
        }
        public async Task<(SecUser, string)> CheckAsync_SecUser(string account, string password, int nOperationType)
        {
            //Holuser user = await context.Holuser.AsNoTracking().FirstOrDefaultAsync(x => x.Account == account);
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                SecUser _oSecUser, _retoSecUser;

                _oSecUser = new SecUser()
                {
                    UserNo = account,
                    Pwd = password
                };
                if (con.State == ConnectionState.Closed) con.Open();
                var oSecUsers = await con.QueryAsync<SecUser>("SP_SecUser_R"
                    , this.SetParmeters_SecUser_R(_oSecUser, nOperationType),
                    commandType: CommandType.StoredProcedure);
                if (!oSecUsers.Any() || oSecUsers == null)
                {
                    return (null, "使用者帳號不存在");
                }
                _retoSecUser = oSecUsers.FirstOrDefault();
                string decryptPwd = CryptoService.Decrypt(_retoSecUser.Pwd);
                if (decryptPwd != password)
                {
                    return (null, "密碼不正確");
                }
                return (_retoSecUser, "");
            }
        }
        #endregion
        #region SecGrp
        public async Task CreateAsync_SecGrp(SecGrp arg_secGrp)
        {
            SecGrp _oSecGrp = new SecGrp();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();

                //依operationType判斷新增或更新
                var oSecGrps = await con.QueryFirstOrDefaultAsync<SecGrp>("SP_SecGrp_CUD"
                    , this.SetParmeters_SecGrp(arg_secGrp, 1),
                    commandType: CommandType.StoredProcedure);

                if (oSecGrps != null)
                {
                    _oSecGrp = (SecGrp)oSecGrps;
                }
            }
        }
        public async Task DeleteAsync_SecGrp(SecGrp arg_secGrp)
        {
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                await con.QueryAsync<SecGrp>("SP_SecGrp_CUD"
                    , this.SetParmeters_SecGrp(arg_secGrp, 3),
                    commandType: CommandType.StoredProcedure);
            }
        }
        private DynamicParameters SetParmeters_SecGrp(SecGrp oSecGrp, int nOperationType)
        {
            DynamicParameters obj = new DynamicParameters();
            obj.Add("@userno", oSecGrp.UserNo);
            obj.Add("@grpno", oSecGrp.GrpNo);
            obj.Add("@OperationType", nOperationType);
            return obj;
        }

        public async Task<List<SecGrp>> RetriveAsync_SecGrp(SecGrp arg_secgrp, int nOperationType)
        {
            List<SecGrp> _oSecGrps = new List<SecGrp>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oSecGrps = con.QueryAsync<SecGrp>("SP_SecGrp_R"
                           , this.SetParmeters_SecGrp(arg_secgrp, nOperationType),
                           commandType: CommandType.StoredProcedure);

                if (oSecGrps != null && oSecGrps.Result.Any())
                {
                    _oSecGrps = (List<SecGrp>)await oSecGrps;
                }
            }
            return _oSecGrps;
        }

        public List<SecGrp> Retrive_SecGrp(SecGrp arg_secgrp, int nOperationType)
        {
            List<SecGrp> _oSecGrps = new List<SecGrp>();
            using (IDbConnection con = new SqlConnection(_connectionString))
            {
                if (con.State == ConnectionState.Closed) con.Open();
                var oSecGrps = con.Query<SecGrp>("SP_SecGrp_R"
                           , this.SetParmeters_SecGrp(arg_secgrp, nOperationType),
                           commandType: CommandType.StoredProcedure);

                if (oSecGrps != null && oSecGrps.Any())
                {
                    _oSecGrps = (List<SecGrp>)oSecGrps;
                }
            }
            return _oSecGrps;
        }


        #endregion
    }
}
