﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using SystemLead.Project.LK.Server.BZSWeb.Models;
using SystemLead.Project.LK.Server.BZSWeb.Models.MIS;

namespace SystemLead.Project.LK.Server.BZSWeb.Services.MIS
{
    public class MisDbEFService : IMisService
    {
        public MyDbContext MyDbContext { get; }

        public MisDbEFService(MyDbContext arg_myDbContext)
        {
            MyDbContext = arg_myDbContext;
        }

        #region MisUnit
        public Task<List<MisUnit>> RetriveAsync_MisUnit(MisUnit arg_misunit, int nOperationType)
        {
            throw new NotImplementedException();
        }
        public List<MisUnit> Retrive_MisUnit(MisUnit arg_misunit, int nOperationType)
        {
            throw new NotImplementedException();
        }
        #endregion
        #region MisDept
        public Task<List<MisDept>> RetriveAsync_MisDept(MisDept arg_misdept, int nOperationType)
        {
            throw new NotImplementedException();
        }

        public List<MisDept> Retrive_MisDept(MisDept arg_misdept, int nOperationType)
        {
            throw new NotImplementedException();
        }
        public List<TreeItem> Retrive_MisDeptTree(MisDept arg_misdept, int nOperationType)
        {
            throw new NotImplementedException();
        }
        #endregion

        public async Task CreateAsync_MisCkind(MisCkind arg_misCkind)
        {
            //EF Table 新增異動
            await MyDbContext.MisCkind.AddAsync(arg_misCkind);
            //EF 非同步儲存
            await MyDbContext.SaveChangesAsync();
        }
        //MisCkind
        public async Task<List<MisCkind>> RetriveAsync_MisCkind(MisCkind arg_misckind, int nOperationType)
        {
            return await MyDbContext.MisCkind.OrderBy(x => x.Ckind).ToListAsync();
        }
        public async Task UpdateAsync_MisCkind(MisCkind arg_misCkind)
        {
            var fooItem = await MyDbContext.MisCkind.FirstOrDefaultAsync(x => x.Ckind == arg_misCkind.Ckind);
            if (fooItem != null)
            {
                fooItem.Ckdesc = arg_misCkind.Ckdesc;
                await MyDbContext.SaveChangesAsync();
            }
        }
        public async Task DeleteAsync_MisCkind(MisCkind arg_misCkind)
        {
            MyDbContext.MisCkind.Remove(await MyDbContext.MisCkind.FirstOrDefaultAsync(x => x.Ckind == arg_misCkind.Ckind));
            await MyDbContext.SaveChangesAsync();
        }
        //MisCode
        public async Task CreateAsync_MisCode(MisCode arg_misCode)
        {
            //EF Table 新增異動
            await MyDbContext.MisCode.AddAsync(arg_misCode);
            //EF 非同步儲存
            await MyDbContext.SaveChangesAsync();
        }
        public async Task<List<MisCode>> RetriveAsync_MisCode(MisCode arg_miscode, int nOperationType)
        {
            return await MyDbContext.MisCode.Where(x => x.Ckind == arg_miscode.Ckind).OrderBy(x => x.Ckind).ThenBy(x => x.Code).ToListAsync();
        }
        public async Task UpdateAsync_MisCode(MisCode arg_misCode)
        {
            var fooItem = await MyDbContext.MisCode.FirstOrDefaultAsync(x => x.Ckind == arg_misCode.Ckind && x.Code == arg_misCode.Code);
            if (fooItem != null)
            {
                fooItem.Cdesc = arg_misCode.Cdesc;
                fooItem.Status = arg_misCode.Status;
                fooItem.Cdesc_s = arg_misCode.Cdesc_s;
                fooItem.Cdesc_e = arg_misCode.Cdesc_e;
                fooItem.Cdesc_j = arg_misCode.Cdesc_j;
                fooItem.Cdesc_o = arg_misCode.Cdesc_o;
                fooItem.Memo = arg_misCode.Memo;

                await MyDbContext.SaveChangesAsync();
            }
        }

        public async Task DeleteAsync_MisCode(MisCode arg_misCode)
        {
            MyDbContext.MisCode.Remove(await MyDbContext.MisCode.FirstOrDefaultAsync(x => x.Ckind == arg_misCode.Ckind && x.Code == arg_misCode.Code));
            await MyDbContext.SaveChangesAsync();
        }

        public Task CreateAsync_MisGrp(MisGrp arg_misGrp)
        {
            throw new NotImplementedException();
        }

        public Task DeleteAsync_MisGrp(MisGrp arg_misGrp)
        {
            throw new NotImplementedException();
        }

        public Task<List<MisGrp>> RetriveAsync_MisGrp(MisGrp arg_misgrp, int nOperationType)
        {
            throw new NotImplementedException();
        }

        public Task UpdateAsync_MisGrp(MisGrp arg_misGrp)
        {
            throw new NotImplementedException();
        }
        //SecUser
        public async Task CreateAsync_SecUser(SecUser arg_secUser)
        {
            //EF Table 新增異動
            await MyDbContext.SecUser.AddAsync(arg_secUser);
            //EF 非同步儲存
            await MyDbContext.SaveChangesAsync();
        }
        public async Task<List<SecUser>> RetriveAsync_SecUser(SecUser arg_secUser, int nOperationType)
        {
            return await MyDbContext.SecUser.OrderBy(x => x.UserNo).ToListAsync();
        }
        public List<SecUser> Retrive_SecUser(SecUser arg_secUser, int nOperationType)
        {
            throw new NotImplementedException();
        }
        public async Task UpdateAsync_SecUser(SecUser arg_secUser)
        {
            var fooItem = await MyDbContext.SecUser.FirstOrDefaultAsync(x => x.UserNo == arg_secUser.UserNo);
            if (fooItem != null)
            {
                fooItem.UserNo = arg_secUser.UserNo;
                fooItem.UserName = arg_secUser.UserName;
                fooItem.Pwd = arg_secUser.Pwd;
                fooItem.Email = arg_secUser.Email;
                fooItem.PFacno = arg_secUser.PFacno;
                fooItem.PDepno = arg_secUser.PDepno;
                fooItem.Enabled = arg_secUser.Enabled;
                fooItem.UType = arg_secUser.UType;
                fooItem.UClass = arg_secUser.UClass;
                fooItem.ProTitle = arg_secUser.ProTitle;
                fooItem.Sex = arg_secUser.Sex;
                await MyDbContext.SaveChangesAsync();
            }
        }
        public async Task DeleteAsync_SecUser(SecUser arg_secUser)
        {
            MyDbContext.SecUser.Remove(await MyDbContext.SecUser.FirstOrDefaultAsync(x => x.UserNo == arg_secUser.UserNo));
            await MyDbContext.SaveChangesAsync();
        }
        public async Task<SecUser> Get_SecUser(string arg_userNo)
        {
            return await MyDbContext.SecUser.Where(x => x.UserNo == arg_userNo).FirstOrDefaultAsync();
        }
        public Task<(SecUser, string)> CheckAsync_SecUser(string account, string password, int nOperationType)
        {
            throw new NotImplementedException();
        }

        public List<MisGrp> Retrive_MisGrp(MisGrp arg_misgrp, int nOperationType)
        {
            throw new NotImplementedException();
        }

        public Task<List<TreeItem>> RetriveAsync_MisGrpUserTree(MisGrp arg_misgrp, int nOperationType)
        {
            throw new NotImplementedException();
        }

        public List<TreeItem1> Retrive_SecUserTree(SecUser arg_secUser, int nOperationType)
        {
            throw new NotImplementedException();
        }
        #region SecGrp
        public Task CreateAsync_SecGrp(SecGrp arg_secGrp)
        {
            throw new NotImplementedException();
        }
        public Task DeleteAsync_SecGrp(SecGrp arg_secGrp)
        {
            throw new NotImplementedException();
        }

        public Task<List<SecGrp>> RetriveAsync_SecGrp(SecGrp arg_secgrp, int nOperationType)
        {
            throw new NotImplementedException();
        }

        public List<SecGrp> Retrive_SecGrp(SecGrp arg_secgrp, int nOperationType)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
