﻿using Dapper;
using Microsoft.Data.SqlClient;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using SystemLead.Project.LK.Server.BZSWeb.Models;

namespace SystemLead.Project.LK.Server.BZSWeb.Services
{
    public class MenuService
    {
        //7-Inject Connection & select menu to list
        private readonly SqlConnectionConfiguration _configuration;

        public MenuService(SqlConnectionConfiguration configuration)
        {
            _configuration = configuration;
        }

        public async Task<IEnumerable<MenuInfo>> GetMenuData(string arg_enabled)
        {
            IEnumerable<MenuInfo> menuinfos;
            string query;

            using (var conn = new SqlConnection(_configuration.Value))
            {
                if (string.IsNullOrEmpty(arg_enabled))
                {
                    query = @"select * from VW_BzsMenu where Enabled not in ('N')";
                }
                else
                {
                    query = @"select * from VW_BzsMenu where (Enabled not in ('N') and Enabled in ('" + arg_enabled + "')) or  Enabled = ''";
                }


                if (conn.State == ConnectionState.Closed)
                    conn.Open();

                try
                {
                    menuinfos = await conn.QueryAsync<MenuInfo>(query);
                }
                catch (Exception ex)
                {
                    throw ex;
                }
                finally
                {
                    if (conn.State == ConnectionState.Open)
                        conn.Close();
                }
            }

            return menuinfos;
        }
    }
}
